3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$GIT_QUIET"
131 if test -n "$reference"
133 git-clone $quiet "$reference" -n "$url" "$path"
135 git-clone $quiet -n "$url" "$path"
137 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
141 # Add a new submodule to the working tree, .gitmodules and the index
145 # optional branch is stored in global branch variable
149 # parse $args after "submodule ... add".
154 case "$2" in '') usage ;; esac
165 case "$2" in '') usage ;; esac
166 reference="--reference=$2"
190 if test -z "$path"; then
191 path=$(echo "$repo" |
192 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
195 if test -z "$repo" -o -z "$path"; then
199 # assure repo is absolute or relative to parent
202 # dereference source url relative to parent's url
203 realrepo=$(resolve_relative_url "$repo") || exit
210 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
215 # multiple //; leading ./; /./; /../; trailing /
216 path=$(printf '%s/\n' "$path" |
226 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
227 die "$(eval_gettext "'\$path' already exists in the index")"
229 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
231 eval_gettextln "The following path is ignored by one of your .gitignore files:
233 Use -f if you really want to add it." >&2
237 # perhaps the path exists and is already a git repo, else clone it
240 if test -d "$path"/.git -o -f "$path"/.git
242 eval_gettextln "Adding existing repo at '\$path' to the index"
244 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
249 module_clone "$path" "$realrepo" "$reference" || exit
253 # ash fails to wordsplit ${branch:+-b "$branch"...}
255 '') git checkout -f -q ;;
256 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
258 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
260 git config submodule."$path".url "$realrepo"
262 git add $force "$path" ||
263 die "$(eval_gettext "Failed to add submodule '\$path'")"
265 git config -f .gitmodules submodule."$path".path "$path" &&
266 git config -f .gitmodules submodule."$path".url "$repo" &&
267 git add --force .gitmodules ||
268 die "$(eval_gettext "Failed to register submodule '\$path'")"
272 # Execute an arbitrary command sequence in each checked out
275 # $@ = command to execute
279 # parse $args after "submodule ... foreach".
301 # dup stdin so that it can be restored when running the external
302 # command in the subshell (and a recursive call to this function)
306 while read mode sha1 stage path
308 if test -e "$path"/.git
310 say "$(eval_gettext "Entering '\$prefix\$path'")"
311 name=$(module_name "$path")
313 prefix="$prefix$path/"
317 if test -n "$recursive"
319 cmd_foreach "--recursive" "$@"
322 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
328 # Register submodules in .git/config
330 # $@ = requested paths (default to all)
334 # parse $args after "submodule ... init".
356 while read mode sha1 stage path
358 # Skip already registered paths
359 name=$(module_name "$path") || exit
360 if test -z "$(git config "submodule.$name.url")"
362 url=$(git config -f .gitmodules submodule."$name".url)
364 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
366 # Possibly a url relative to parent
369 url=$(resolve_relative_url "$url") || exit
372 git config submodule."$name".url "$url" ||
373 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
376 # Copy "update" setting when it is not set yet
377 upd="$(git config -f .gitmodules submodule."$name".update)"
379 test -n "$(git config submodule."$name".update)" ||
380 git config submodule."$name".update "$upd" ||
381 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
383 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
388 # Update each submodule path to correct revision, using clone and checkout as needed
390 # $@ = requested paths (default to all)
394 # parse $args after "submodule ... update".
415 case "$2" in '') usage ;; esac
416 reference="--reference=$2"
417 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
440 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
446 cmd_init "--" "$@" || return
452 while read mode sha1 stage path
456 echo >&2 "Skipping unmerged submodule $path"
459 name=$(module_name "$path") || exit
460 url=$(git config submodule."$name".url)
461 update_module=$(git config submodule."$name".update)
464 # Only mention uninitialized submodules when its
465 # path have been specified
467 say "$(eval_gettext "Submodule path '\$path' not initialized
468 Maybe you want to use 'update --init'?")"
472 if ! test -d "$path"/.git -o -f "$path"/.git
474 module_clone "$path" "$url" "$reference"|| exit
475 cloned_modules="$cloned_modules;$name"
478 subsha1=$(clear_local_git_env; cd "$path" &&
479 git rev-parse --verify HEAD) ||
480 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
483 if ! test -z "$update"
485 update_module=$update
488 if test "$subsha1" != "$sha1"
491 # If we don't already have a -f flag and the submodule has never been checked out
492 if test -z "$subsha1" -a -z "$force"
497 if test -z "$nofetch"
499 # Run fetch only if $sha1 isn't present or it
500 # is not reachable from a ref.
501 (clear_local_git_env; cd "$path" &&
502 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
503 test -z "$rev") || git-fetch)) ||
504 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
507 # Is this something we just cloned?
508 case ";$cloned_modules;" in
510 # then there is no local change to integrate
515 case "$update_module" in
518 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
519 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
520 must_die_on_failure=yes
524 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
525 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
526 must_die_on_failure=yes
529 command="git checkout $subforce -q"
530 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
531 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
535 if (clear_local_git_env; cd "$path" && $command "$sha1")
538 elif test -n "$must_die_on_failure"
540 die_with_status 2 "$die_msg"
542 err="${err};$die_msg"
547 if test -n "$recursive"
549 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
553 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
556 err="${err};$die_msg"
559 die_with_status $res "$die_msg"
586 git describe "$2" 2>/dev/null ||
587 git describe --tags "$2" 2>/dev/null ||
588 git describe --contains "$2" 2>/dev/null ||
589 git describe --all --always "$2"
592 test -z "$revname" || revname=" ($revname)"
595 # Show commit summary for submodules in index or working tree
597 # If '--cached' is given, show summary between index and given commit,
598 # or between working tree and given commit
600 # $@ = [commit (default 'HEAD'),] requested paths (default all)
607 # parse $args after "submodule ... summary".
621 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
643 test $summary_limit = 0 && return
645 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
649 elif test -z "$1" -o "$1" = "HEAD"
651 # before the first commit: compare with an empty tree
652 head=$(git hash-object -w -t tree --stdin </dev/null)
653 test -z "$1" || shift
661 die "$(gettext -- "--cached cannot be used with --files")"
667 # Get modified modules cared by user
668 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
669 sane_egrep '^:([0-7]* )?160000' |
670 while read mod_src mod_dst sha1_src sha1_dst status name
672 # Always show modules deleted or type-changed (blob<->module)
673 test $status = D -o $status = T && echo "$name" && continue
674 # Also show added or modified modules which are checked out
675 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
680 test -z "$modules" && return
682 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
683 sane_egrep '^:([0-7]* )?160000' |
685 while read mod_src mod_dst sha1_src sha1_dst status name
687 if test -z "$cached" &&
688 test $sha1_dst = 0000000000000000000000000000000000000000
692 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
694 100644 | 100755 | 120000)
695 sha1_dst=$(git hash-object $name)
701 eval_gettextln "unexpected mode \$mod_dst" >&2
708 test $mod_src = 160000 &&
709 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
712 test $mod_dst = 160000 &&
713 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
717 case "$missing_src,$missing_dst" in
719 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
722 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
725 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
730 if test $mod_src = 160000 -a $mod_dst = 160000
732 range="$sha1_src...$sha1_dst"
733 elif test $mod_src = 160000
739 GIT_DIR="$name/.git" \
740 git rev-list --first-parent $range -- | wc -l
742 total_commits=" ($(($total_commits + 0)))"
746 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
747 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
750 blob="$(gettext "blob")"
751 submodule="$(gettext "submodule")"
752 if test $mod_dst = 160000
754 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
756 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
759 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
763 # Don't give error msg for modification whose dst is not submodule
764 # i.e. deleted or changed to blob
765 test $mod_dst = 160000 && echo "$errmsg"
767 if test $mod_src = 160000 -a $mod_dst = 160000
770 test $summary_limit -gt 0 && limit="-$summary_limit"
771 GIT_DIR="$name/.git" \
772 git log $limit --pretty='format: %m %s' \
773 --first-parent $sha1_src...$sha1_dst
774 elif test $mod_dst = 160000
776 GIT_DIR="$name/.git" \
777 git log --pretty='format: > %s' -1 $sha1_dst
779 GIT_DIR="$name/.git" \
780 git log --pretty='format: < %s' -1 $sha1_src
786 if test -n "$for_status"; then
787 if [ -n "$files" ]; then
788 gettextln "# Submodules changed but not updated:"
790 gettextln "# Submodule changes to be committed:"
793 sed -e 's|^|# |' -e 's|^# $|#|'
799 # List all submodules, prefixed with:
800 # - submodule not initialized
801 # + different revision checked out
803 # If --cached was specified the revision in the index will be printed
804 # instead of the currently checked out revision.
806 # $@ = requested paths (default to all)
810 # parse $args after "submodule ... status".
835 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
840 while read mode sha1 stage path
842 name=$(module_name "$path") || exit
843 url=$(git config submodule."$name".url)
844 displaypath="$prefix$path"
847 say "U$sha1 $displaypath"
850 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
852 say "-$sha1 $displaypath"
855 set_name_rev "$path" "$sha1"
856 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
858 say " $sha1 $displaypath$revname"
862 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
863 set_name_rev "$path" "$sha1"
865 say "+$sha1 $displaypath$revname"
868 if test -n "$recursive"
871 prefix="$displaypath/"
874 eval cmd_status "$orig_args"
876 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
881 # Sync remote urls for submodules
882 # This makes the value for remote.$remote.url match the value
883 # specified in .gitmodules.
908 while read mode sha1 stage path
910 name=$(module_name "$path")
911 url=$(git config -f .gitmodules --get submodule."$name".url)
913 # Possibly a url relative to parent
916 url=$(resolve_relative_url "$url") || exit
920 if git config "submodule.$name.url" >/dev/null 2>/dev/null
922 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
923 git config submodule."$name".url "$url"
925 if test -e "$path"/.git
930 remote=$(get_default_remote)
931 git config remote."$remote".url "$url"
938 # This loop parses the command line arguments to find the
939 # subcommand name to dispatch. Parsing of the subcommand specific
940 # options are primarily done by the subcommand implementations.
941 # Subcommand specific options such as --branch and --cached are
942 # parsed here as well, for backward compatibility.
944 while test $# != 0 && test -z "$command"
947 add | foreach | init | update | status | summary | sync)
977 # No command word defaults to "status"
978 test -n "$command" || command=status
980 # "-b branch" is accepted only by "add"
981 if test -n "$branch" && test "$command" != add
986 # "--cached" is accepted only by "status" and "summary"
987 if test -n "$cached" && test "$command" != status -a "$command" != summary